
;16-bit program
;long multiply 32-bit x 32-bit
;DednDave 6-2011

        .MODEL  Small
        .STACK  4096

;-------------------------------------------------------------

        .DATA

A       dd      1234567890,0
B       dd      2345678901,0

buffer  db      20 dup(?)
CrLf    db      0Dh,0Ah,24h
AnyKey  db      'Press Any Key to Continue...',24h

;------------------------

        .DATA?

product dw      4 dup(?)
count   dw      ?

;-------------------------------------------------------------

        .CODE
        ASSUME  DS:DGROUP

_main   PROC

        mov     ax,@DATA
        mov     ds,ax

        mov     si,offset A
        mov     di,offset B
        mov     bx,offset product
        call    LongMul

        mov     si,offset A
        mov     di,offset buffer
        call    B2Asc64
        mov     ah,9
        int     21h

        mov     si,offset B
        mov     di,offset buffer
        call    B2Asc64
        mov     ah,9
        int     21h

        mov     si,offset product
        mov     di,offset buffer
        call    B2Asc64
        mov     ah,9
        int     21h

        mov     dx,offset CrLf
        mov     ah,9
        int     21h
        mov     dx,offset AnyKey
        mov     ah,9
        int     21h
        mov     ah,0
        int     16h
        mov     dx,offset CrLf
        mov     ah,9
        int     21h

        mov     ax,4C00h
        int     21h

_main   ENDP

;-------------------------------------------------------------

LongMul PROC

;32-bit x 32-bit long multiply
;non-destructive
;DednDave 6-2011

;Call With: BX = address of 64-bit result buffer
;           SI = address of 32-bit multiplier
;           DI = address of 32-bit multiplicand
;
;  Returns: [BX] = 64-bit binary result
;           BX, SI, DI, BP registers preserved
;           requires use of word variable 'count'

        push    si
        push    di
        push    bp
        xor     ax,ax               ;zero AX register

;zero out the product

        mov     [bx],ax
        mov     [bx+2],ax
        mov     [bx+4],ax
        mov     [bx+6],ax

;load the multiplicand into DX:AX:DI:CX

        mov     cx,[di]
        mov     dx,ax
        mov     di,[di+2]

;test bit in BP and initialize count variable

        mov     bp,1
        mov     count,2

;32-bit x 32-bit long multiply

top_of_loop:
        test    bp,[si]
        jz      next_bit

        add     [bx],cx
        adc     [bx+2],di
        adc     [bx+4],ax
        adc     [bx+6],dx

next_bit:
        shl     cx,1
        rcl     di,1
        rcl     ax,1
        rcl     dx,1
        rol     bp,1
        jnc     top_of_loop

        add     si,2
        dec     count
        jnz     top_of_loop

        pop     bp
        pop     di
        pop     si
        ret

LongMul ENDP

;-------------------------------------------------------------

B2Asc64 PROC

;convert a 64-bit binary value to ASCII decimal string
;non-destructive
;terminating the string is the responsibility of the caller
;DednDave 6-2011

;Call With: SI = address of 64-bit binary value
;           DI = address of 20 byte buffer
;
;  Returns: DX = offset of first numeric character in buffer
;           CX = 3030h
;           BX, SI, DI, BP registers preserved

        push    di
        push    bx
        push    bp
        mov     bp,sp
        push word ptr [si+6]
        add     di,20
        push word ptr [si+4]
        mov     bx,100
        push word ptr [si+2]
        mov     cx,3030h
        push word ptr [si]

B2Asc0: xor     dx,dx
        mov     ax,[bp-2]
        sub     di,2
        div     bx
        mov     [bp-2],ax
        mov     ax,[bp-4]
        div     bx
        mov     [bp-4],ax
        mov     ax,[bp-6]
        div     bx
        mov     [bp-6],ax
        mov     ax,[bp-8]
        div     bx
        mov     [bp-8],ax
        xchg    ax,dx
        aam
        mov     dx,[bp-2]
        xchg    al,ah
        or      dx,[bp-4]
        or      ax,cx
        or      dx,[bp-6]
        mov     [di],ax
        or      dx,[bp-8]
        jnz     B2Asc0

        add     sp,8
        mov     dx,di
        pop     bp
        cmp     cl,[di]
        pop     bx
        pop     di
        sbb     dx,-1
        ret

B2Asc64 ENDP

;-------------------------------------------------------------

        END     _main

